IDS={}
class UniqueId:    
    def __init__(self,group=None):
        self.idgroup=group
        if group==None:
            group=self.__class__.__name__
        if not group in IDS:
            IDS[group]={}
            
        n=0
        while 1:
            if not n in IDS[group]:
                IDS[group][n]=self
                self.uid=n
                self.uids=repr(n)
                return
            n+=1
            
    def _freeid(self):
        if self.idgroup==None:
            group=self.__class__.__name__        
        else:
            group=self.idgroup
        IDS[group].pop(self.uid)
        
        
class IDmgr:
    def __init__(self):
        self.ids={}
        self.minfree=0
        
    def nextid(self,group):        
        if not group in self.ids:
            g={}
            self.ids[group]=g
        else:
            g=self.ids[group]
            
        i=self.minfree        
        while 1:
            if not i in g:
                g[i]=None
                break
            i+=1
        return i
        self.minfree=i+1
    
    def freeid(self,id,group):
        g=self.ids[group]                
        assert(id in g)
        g.pop(id)
        if id<self.minfree:
            self.minfree=g
            

        

def test1():

    def printidlist(lst):
        for l in lst:
            print l.uid,
        print
    
    ids=[]
    for i in xrange(10):
        ids.append(UniqueId())
        
    printidlist(ids)

    for i in xrange(5):
        id=ids.pop(0)
        id._freeid()
        
    printidlist(ids)
        
    for i in xrange(10):
        ids.append(UniqueId())
        
    printidlist(ids)
    
    
def test2():
    ids=IDmgr()    
    for i in xrange(5):
        ids.nextid('one')
        
    for i in xrange(5):
        ids.nextid('two')
    
    ids.freeid(1,'one')
    ids.freeid(3,'one')
    
    ids.freeid(2,'two')
    ids.freeid(4,'two')
        
    print 'one:',ids.ids['one'].keys()
    print 'two:',ids.ids['two'].keys()
    
    for i in xrange(5):
        ids.nextid('one')
        
    for i in xrange(5):
        ids.nextid('two')
    
    print 'one:',ids.ids['one'].keys()
    print 'two:',ids.ids['two'].keys()
                
        
if __name__=="__main__":
    test1()
    test2()